package jexplorer;

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 16.03.2013
*/

import javax.swing.*;

import java.awt.*;

import java.io.*;

import java.util.Date;

import java.awt.event.*;
import java.text.SimpleDateFormat;


//Tabelle
import javax.swing.table.*;

// Schalter event
import java.awt.event.*;

// Sortieren
import java.util.Collections;

import java.util.Vector;



public class CTable  extends JPanel implements ITableSetDir {
    static int C_Filterindex=0;
   JTable tabelle;
   Vector<CFile> _tabellenliste = new Vector();
   
   CStatusBar statusBar;

   JComboBox comboFilter;   
   // dient zur Anzeige UND zur Auswahl, siehe Klasse CFileFilter2, Methode accept
   Vector<CFileFilter2> _filterListe;

   String _sDirectory="";
   
   Vector _kopyListe= new Vector();
   String _sKopyDirectory="";
    
   IExplorer _parent;
   JFrame _superframe;

   JToolBar _toolBar;

    final String[] names = {"Dateiname", "Typ", "Lnge", "Datum / Zeit"};
    
    /** Creates a new instance of MyTable */
    public CTable(CStatusBar statusBar, IExplorer parent, JFrame superframe) {
        _parent = parent;
        _superframe = superframe;
        setLayout( new BorderLayout() );
        this.statusBar = statusBar;
        setToolBar();

        
        /*
         tabelle = createTable();
        
        JScrollPane scrollpane = new JScrollPane(tabelle);
        add(scrollpane, BorderLayout.CENTER);
        */
      // tabelle.setFont( new Font("Arial", Font.BOLD,18)  );

  }

    private void setToolBar() {
       
        _toolBar = new JToolBar();
        JLabel  label1 = new JLabel("Filter");
        _toolBar.add( label1 );
        label1.setFont( new Font("Arial", Font.BOLD,18)  );

        _toolBar.addSeparator( new Dimension(20,5) );

        add(_toolBar, BorderLayout.NORTH);
            
        _filterListe = new Vector();
        _filterListe.add( new  CFileFilter2( "Alle") );
        _filterListe.add( new  CFileFilter2("Java", new String[] {".JAVA"}) );
        _filterListe.add( new  CFileFilter2("C, C++", new String[] {".C",".CPP"}) );
        _filterListe.add( new  CFileFilter2("Doku", new String[] {".DOC",".XLS",".PDF"}) );
        _filterListe.add( new  CFileFilter2("Texte", new String[] {".TXT",".DAT"}) ); 
        _filterListe.add( new  CFileFilter2("Progs", new String[] {".EXE"}) );
        comboFilter = new JComboBox(_filterListe);

        comboFilter.setSelectedIndex( C_Filterindex );
        _toolBar.add( comboFilter );
        comboFilter.setFont( new Font("Arial", Font.BOLD,18)  );


        comboFilter.addActionListener(new java.awt.event.ActionListener() {

        public void actionPerformed(ActionEvent e) {
          comboFilter_click();
       }
      });

        add(_toolBar, BorderLayout.NORTH);
        
    }

 
    
  // createTable
  public JTable createTable() {
    // Create a model of the data.
        TableModel dataModel = new AbstractTableModel() {
            // These methods always need to be implemented.
            public int getColumnCount() {
              return names.length;
            }
            public int getRowCount() {
              return _tabellenliste.size();
            }
            
            public Class getColumnClass(int c) {
              return getValueAt(0, c).getClass();
            }

            public Object getValueAt(int row, int col) {
                long size;
                long date;
                String sDate;
                String sSize;
                SimpleDateFormat df;
                // System.out.println("in getValueAt row:"+row+"   col:"+col);
              CFile myfile = _tabellenliste.elementAt(row);
              switch (col) {
                  case 0: return myfile.Name;
                  case 1: return myfile.Ext;
                  case 2: size = myfile.length;
                          sSize = CBasis.Long2_StrKomma( size );
                          return sSize;
                  case 3: date = myfile.date;
                          Date dt = new Date(date);
                          df = new SimpleDateFormat("dd.MM.yyyy-hh:mm:ss"); 
      		          // letzte Aenderung der Datei zurueckgeben
      		          sDate = df.format(dt);
                          return sDate;
                  default: return "xxxxx"+Integer.toString(col);
              }
            }

            // The default implementations of these methods in
              // AbstractTableModel would work, but we can refine them.
            public String getColumnName(int column) {
              return names[column];
            }

        
        };

       
        JTable table = new JTable(dataModel);
         table.setAutoCreateRowSorter(true);

        return table;
  } // createTable



    public int getButton(MouseEvent e) {
        int mode = e.getModifiers();
        if ((mode & e.BUTTON2_MASK) > 0) {
            return 2;
        }
        if ((mode & e.BUTTON3_MASK) > 0) {
            return 3;
        }
        return 1;
    } // getButton

      void tabelle_mouseClicked(MouseEvent e) {
        if (  getButton(e) == 1) {
           if ( e.getClickCount() == 2) {
            //System.out.println("doppel");
           }
           if ( e.getClickCount() == 1) {
            System.out.println("einfach");
            setSelectInfo();
            runItem();
           }
         }
        if (  getButton(e) == 3) {
           popupMenu( e ) ;
         }
        
      }


    public void reload() {
        setDir(  _sDirectory );
    }
    
    
    public void setDir1( String sPath ) {
        return;
    }
    
    public void setDir( String sPath ) {     
        CFile myfile;
        _sDirectory = sPath;
      	File dir = new File( sPath );
        // File[] items = dir.listRoots();
        File[] items = dir.listFiles();
        // Umwandeln in Vector
        _tabellenliste.removeAllElements();
        int i = comboFilter.getSelectedIndex();
        boolean bMitFilter=false;
        CFileFilter2 filefilter;
        if (i>=0) {
            // Filter suchen
            filefilter = _filterListe.elementAt(i);
            for (i=0; i<items.length; i++) {
                if ( items[i].isFile() && (!items[i].isHidden() )      ) {
                    // Filter einbauen
                    String sFileName = items[i].getAbsolutePath();
                    if (filefilter.accept(sFileName) ) {
                        myfile = new CFile( items[i] );
                        _tabellenliste.add( myfile );  // clonen
                    }
                }
            }
        }
        else {
            // ohne Prfung schneller
            for (i=0; i<items.length; i++) {
                if ( items[i].isFile() && (!items[i].isHidden() )      ) {
                   myfile = new CFile( items[i] );
                   _tabellenliste.add( myfile );  // clonen
                }
            }
            
        }
                
        removeAll();
        setToolBar();

        tabelle = createTable();
        
        JScrollPane scrollpane = new JScrollPane(tabelle);
        
        scrollpane.addMouseListener(new java.awt.event.MouseAdapter() {

          public void mouseClicked(MouseEvent e) {
            tabelle_mouseClicked(e);
          }
        });
        
        add(scrollpane, BorderLayout.CENTER);
        
        // tabelle.setColumnSelectionAllowed(true);
        tabelle.setGridColor(Color.red);
        
       tabelle.setFont( new Font("Arial", Font.BOLD,18)  );
       // tabelle.updateUI();
       // tabelle.paintImmediately(  tabelle.getBounds() );  // not really
       
        tabelle.addMouseListener(new java.awt.event.MouseAdapter() {

          public void mouseClicked(MouseEvent e) {
            tabelle_mouseClicked(e);
          }
        });
       
       updateUI();  // dies wrgt !
        
    }   
    
  
   
   private void comboFilter_click() {
       int i = comboFilter.getSelectedIndex();
       // da die gesamte Komponente ausgetauscht wird, muss
       // man diesen Wert speichern
       C_Filterindex=i;  
       reload();
   }
           
   
   
   public String getSelectedFile() {
       String sFile;
        int i = tabelle.getSelectedRow();
        // Eintrag selektiert ?
        if (i>=0) {
            CFile myfile = _tabellenliste.elementAt(i);
            sFile = myfile.fullPath;
        }
        else {
           sFile = null;
        }
        return sFile;       
   }
   
    private void runItem() {
        int i = tabelle.getSelectedRow();
        // Eintrag selektiert ?
        if (i>=0) {
            CFile myfile = _tabellenliste.elementAt(i);
            String s = myfile.fullPath;
            System.out.println(s);
            String sExt = myfile.Ext;
            if (  (sExt.compareToIgnoreCase("EXE")==0) ||
                  (sExt.compareToIgnoreCase("COM")==0) || 
                  (sExt.compareToIgnoreCase("BAT")==0)  ) {
                 try {
                    System.out.println("Eintrag ist ein Programm: "+s);
                     Runtime.getRuntime().exec(s);
                }
                catch (IOException e2) {
                }
            }
        }
        
    }

        // Aufgerufen vom Tree
    public void setCut() {
       lk_deleteFile();
    }
    
    public void setCopy() {
        lk_copyFile();
    }
        
    public void setInsert() {
        lk_pasteFile();
    }
    
    private void lk_selectALL() {
        System.out.println("selectAll");
        tabelle.selectAll();
        
    }
    
    public void selectALL(){
        lk_selectALL();
    }
    
    private void setSelectInfo() {
      long summe=0;
      int n;
      int iFiles [] = tabelle.getSelectedRows();
      n = iFiles.length;
      if (n>0) {
          for (int i=0; i<iFiles.length; i++) {
              CFile myfile = _tabellenliste.elementAt( iFiles[i] );
              summe+=myfile.length;
          }     
          statusBar.setText2( Integer.toString(iFiles.length) +
                  " Dateien markiert. "+CBasis.Long2_StrKomma( summe )+" Bytes"
                  );
      }
      else {
          statusBar.setText2( " " );
          
      }
        
    }
    public void changeSelect(){
        // int sel[] = tabelle.getSelectedRows();
        for (int i=0; i<_tabellenliste.size(); i++) {
            tabelle.changeSelection(i,0,true,false);
        }
    }
    
  public void lk_mkdir() {
    String sDir = CBasis.getInput("Anlegen eines Verzeichnisses",_sDirectory);
    if (sDir != null) {
        File f = new File(_sDirectory+sDir);
        if ( f.mkdir() ) {
           _parent.reloadNode(_sDirectory);
        }else {
            CBasis.Error("Anlagen eines Verzeichnisses",
                    "Fehler beim Anlegen:\n"+_sDirectory+sDir);
        }
    }
  }
  
  
  public void  lk_openFile() {
      System.out.println("open");
      runItem();
  }

  public void CountRowsFiles() {
      Vector liste = new Vector();
      int iFiles [] = tabelle.getSelectedRows();
      if (iFiles.length>0) {
          for (int i=0; i<iFiles.length; i++) {
              CFile myfile = _tabellenliste.elementAt( iFiles[i] );
              liste.add( myfile );
          }     
          JFRowCount frame = new JFRowCount();
          frame.setVisible(true);
          frame.calcRowsCount(liste);
      }
      else {
          CBasis.Message("Funktion Zeilensummen berechnen","Bitte markieren Sie mindestens eine Datei");
      }
  }
  public void lk_copyFile() {
      System.out.println("copy");
      // fcb_basis.Message("kopy","copy");
      long summe=0;
      _kopyListe.clear();
      int iFiles [] = tabelle.getSelectedRows();
      for (int i=0; i<iFiles.length; i++) {
          CFile myfile = _tabellenliste.elementAt( iFiles[i] );
          _kopyListe.add(myfile);
          summe+=myfile.length;
      }     
      _sKopyDirectory = _sDirectory;
      statusBar.setText2( Integer.toString(iFiles.length) +
              " Dateien markiert. "+CBasis.Long2_StrKomma( summe )+" Bytes"
              );
  }
  
  
  public void lk_pasteFile() {
      System.out.println("insert");
      //fcb_basis.Message("insert","insert");
      if ( _sDirectory.compareToIgnoreCase(_sKopyDirectory) == 0) {
        CBasis.Error("Einfgen","Sie drfen die dateien nicht in gleiche Verzeichnis einfgen");
          
      }
      
      // hole aktuelle Direktory
      String sDest=_sDirectory;
      String z = sDest.substring( sDest.length()-1 );
      if (z.compareTo("\\") != 0 ) {
          sDest+="\\";
      }
      String sSrc=_sKopyDirectory;
      z = sSrc.substring( sSrc.length()-1 );
      if (z.compareTo("\\") != 0 ) {
          sDest+="\\";
      }

      JFCopyDialog frame =  new JFCopyDialog(this, sSrc ,  sDest, _kopyListe);      
      
      frame.setVisible(true);
      frame.copyFiles();

      statusBar.setText2( " ");
      
      // setDir( sDirectory );
      
  }

  // Problem: Nur Vater, Frame, kann ein JDialog aufrufen
  // 1. Lsung: parent runtergeben, schlecht  Interface
  // 2. Lsung: neue Interface-Methode
  public void lk_renameFile() {
        int i = tabelle.getSelectedRow();
        // Eintrag selektiert ?
        if (i>=0) {
            CFile myfile = _tabellenliste.elementAt(i);
            String sFile = myfile.fullPath;
            JDRenameFile frame = new JDRenameFile(_superframe,sFile);
            if (frame.getResult() )  {
                String sNewFile = frame.getNewName();
                // nun Umbenennen
                File fileOld = new File(sFile);
                File fileNew = new File(sNewFile);
                if (  fileOld.renameTo(fileNew) ) {
                    setDir( _sDirectory );
                }
                else  {
                    CBasis.Error("Fehler","Fehler beim Umbenennen\n"+
                            "Alt: "+sFile+"\n"+
                            "Neu: "+sNewFile
                            );                
                } // 
            } // if frame.getResult
        } // if i>=0
  }
  
  public void lk_deleteFile()  {
      int iFiles [] = tabelle.getSelectedRows();
      int n=iFiles.length;
      CFile myfile;
      File file;
      // wenn mindestens eine Datei selektiert, dann Frage ob Lschen
      if ( n >0 ) {
          if ( CBasis.YesNo("Dateien lschen",
                   "Wollen Sie wirklich die "+Integer.toString(n)+
                   " Dateien lschen?") ){
              // Von hinten lschen, da sonst Index falsch
              for (int i=n-1; i>=0; i--) {
                  int j = iFiles[i];
                  myfile =  _tabellenliste.elementAt( j );
                  _tabellenliste.remove(j);
                  file = new File( myfile.fullPath);
                  file.delete();
              }
              tabelle.updateUI();
          }
      }
      statusBar.setText2( " ");

  }
   
		// Popup-Menue fuer Kopieren Oeffnen und Loeschen
    	public void popupMenu( MouseEvent me ) {
      		JPopupMenu popup = new JPopupMenu();
	  		//Menueeintrag Oeffnen
      		JMenuItem lkOpen = new JMenuItem("ffnen");
                
                    lkOpen.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_openFile();
                    }
                     });

                lkOpen.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(lkOpen);

                //Meneueintag Kopieren
      		JMenuItem kopieren = new JMenuItem("Kopieren");
                    kopieren.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_copyFile();
                    }
                     });
                kopieren.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(kopieren);

                //Menueeintag Loeschen
      		JMenuItem lkPaste = new JMenuItem("Einfgen");
                    lkPaste.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_pasteFile();
                    }
                     });
                lkPaste.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(lkPaste);

                //Menueeintag Loeschen
      		JMenuItem lkDelete = new JMenuItem("Lschen");
                    lkDelete.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_deleteFile();
                    }
                     });
                lkDelete.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(lkDelete);
                
                popup.addSeparator();
      		JMenuItem mkdir = new JMenuItem("Verzeichnis anlegen");
                
                    mkdir.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_mkdir();
                    }
                     });

                mkdir.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(mkdir);

                
                popup.addSeparator();
      		JMenuItem renameFile = new JMenuItem("Datei umbenennen");
                
                    renameFile.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_renameFile();
                    }
                     });

                renameFile.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(renameFile);

                // -----------
                popup.addSeparator();
      		JMenuItem selectAll = new JMenuItem("Alles markieren");
                
                    selectAll.addActionListener(new java.awt.event.ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                        lk_selectALL();
                    }
                     });

                selectAll.setFont( new Font("Arial", Font.BOLD,18)  );        
      		popup.add(selectAll);
                
                
                popup.show(me.getComponent(),me.getX(),me.getY());
       	}//popupMenu

		//Datei oeffnen (noch nicht implementiert!!)
   		public void oeffnenFile() {
      		JOptionPane.showMessageDialog( null,"ffnen noch nicht realisiert !","ffnen",JOptionPane.INFORMATION_MESSAGE);
    	}//oeffnenFile

    
}  // class  MyTable






class CFileFilter2 {
    private String _sName;
    private Vector _Filter=null;
    private boolean bAlle=false;
    
    public CFileFilter2(String sName) {
        _sName = sName;
        bAlle = true;
    }

    public CFileFilter2(String sName, String sFilter[]) {
        _sName = sName;
        _Filter = new Vector();
        for (int i=0; i<sFilter.length; i++) {
            _Filter.add( sFilter[i] );
        }
        bAlle = false;
    }
    
    public String toString() {
        return _sName;
    }
    
    
    public boolean accept(String sFileName) {
        if (bAlle) {
            return true;
        }
        else {
            String sExt = CBasis.getFileExt( sFileName );
            boolean bOkay=false;
            for (int i=0; i<_Filter.size(); i++) {
               String sMaske = (String) _Filter.elementAt(i);            
               if ( sExt.compareToIgnoreCase( sMaske )==0 ) {
                   bOkay=true;
               }
                   
            }
            return bOkay;
        }
    }
}