package jexplorer;

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/


// Dialogfenster, um Einstellungen vorzunehmen
// nur das Gerst fertig

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;


public class JDOptions extends JDialog {
  
   
  JComboBox fontNameComboBox = new JComboBox();

  JSpinner spFontsize;

 JLabel labelTestfont;

 boolean _bStart=true;
 
  boolean _bResult=false;
  
    /** Creates a new instance of JDOptions */
    public JDOptions(Frame parent) {
        super(parent);
        super.setModal(true);
        setGUI();
    
        _bStart=false;
        
        CBasis.centerScreen(this,null);
        setVisible(true);
    }
    
    private void setGUI() {
        setSize(450, 390);
        setTitle("Einstellungen");
        this.getContentPane().setLayout( new GridBagLayout() );

        JLabel label1 = new JLabel("Allgemeine Einstellungen");
        label1.setFont( new Font("Arial", Font.BOLD,18)  );        

        this.getContentPane().add(label1, 
                new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(10,10,0,10), 0, 0));

        // -----------
        JLabel label2 = new JLabel("Schriftname");
        label2.setFont( new Font("Arial", Font.BOLD,14)  );        

        this.getContentPane().add(label2, 
                new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(40,10,0,10), 0, 0));

        
        
        GraphicsEnvironment graphicsEnvironment;
        graphicsEnvironment = GraphicsEnvironment.getLocalGraphicsEnvironment();
        
        String fonts1[] = graphicsEnvironment.getAvailableFontFamilyNames();
        
        // JFonts fonts[] = graphicsEnvironment.getAllFonts();
        // fontNameComboBox.setModel(new DefaultComboBoxModel(availableFonts));
        fontNameComboBox.setModel(new DefaultComboBoxModel(fonts1));
            

        this.getContentPane().add(fontNameComboBox, 
                new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(40,10,0,10), 0, 0));
        
        // ---------------------------------
      JLabel label3 = new JLabel("Schriftgre");
        label3.setFont( new Font("Arial", Font.BOLD,14)  );        
                                    // Aktueller Wert, Min, Max, Increment
      spFontsize = new JSpinner( new SpinnerNumberModel(14,2, 100, 1)   );
      spFontsize.setFont( new Font("Arial", Font.BOLD,14)  );        
      
        this.getContentPane().add(label3, 
                new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(40,10,0,0), 0, 0));

        this.getContentPane().add(spFontsize, 
                new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(40,10,0,10), 0, 0));
        
        
      labelTestfont = new JLabel("The brown Fox jump over all");
                                    // Aktueller Wert, Min, Max, Increment
        labelTestfont.setFont( new Font("Arial", Font.BOLD,14)  );        
      
        this.getContentPane().add(labelTestfont, 
                new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(40,10,0,10), 0, 0));
        
        // ---------------------------
        
        JButton BnOk = new JButton("Ok");
        JButton BnESC = new JButton("Abbruch");
        
        BnOk.setFont( new Font("Arial", Font.BOLD,14)  );        
        BnESC.setFont( new Font("Arial", Font.BOLD,14)  );        

    
        JPanel panelBn = new JPanel();
        panelBn.add(BnOk);
        panelBn.add(BnESC);


        this.getContentPane().add(panelBn,  
                new GridBagConstraints(0, 4, 2, 1, 1.0, 0.0
                ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, 
                new Insets(30,0,10,20), 0, 0));

        BnOk.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            BnOk_Click();
          }
        });
        
        BnESC.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            BnESC_Click();
          }
        });
        
        // Actionperformed
        spFontsize.addChangeListener(new javax.swing.event.ChangeListener() {
                public void stateChanged(javax.swing.event.ChangeEvent evt) {
                    changeFontsize(evt);
                }
            });

        fontNameComboBox.addActionListener(new java.awt.event.ActionListener() {

          public void actionPerformed(ActionEvent e) {
            fontNameComboBox_click();
          }
        });
            
        
        
    } // setGUI
    
    
      // JSpinner ist numerisch
    private void changeFontsize(javax.swing.event.ChangeEvent evt) {
        if (_bStart)  return;
        Integer I = (Integer) spFontsize.getValue();
        setFont();
        System.out.println( I.intValue() );
    }
    
    private void fontNameComboBox_click() {
        if (_bStart)  return;
        setFont();
    }
    
    private void setFont() {
        Integer I = (Integer) spFontsize.getValue();
        int fontsize = I.intValue();
        int i = fontNameComboBox.getSelectedIndex();
        if (i>=0) {
            String sFont = (String) fontNameComboBox.getSelectedItem();
            labelTestfont.setFont( new Font(sFont, Font.BOLD,fontsize)  );        
        }
        
    }

    private void BnESC_Click() {
        _bResult=false;
        dispose();
    }

    // jetzt noch mit keiner Plausibilittsprfung
    private void BnOk_Click() {
        _bResult=true;
        // Plausibilittsprfung
        dispose();
    }
    
    // liefert den Wert, on Ok oder Abbruch gedrckt wurde
    public boolean getResult() {
        return _bResult;
    }
    
}
