package jexplorer;

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Dialogfenster zum Anzeigen der Programm-Info

import javax.swing.*;

import java.awt.event.*;

import java.awt.*;

import java.io.*;


public class JDProgInfo extends JDialog{
    final String C_Copyright = "(c) 2006, by Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm";
    final String C_Version = "Version 0.8, Build 130, 25.11.2006";

    JFrame _parent;
      
      JLabel label6;
      JLabel label7;

    /** Creates a new instance of CProgInfo */
    public JDProgInfo(JFrame parent) {
        super(parent);
        _parent = parent;
        setGUI();
        CBasis.centerScreen(this,null);
        this.setModal(true);
    }
    
    private void setGUI() {
        setSize(600,470);
        setTitle("Info ber JExplorer");
        this.getContentPane().setLayout( new GridBagLayout() );

        JLabel label1 = new JLabel("Programm-Info");
        label1.setIcon( loadIcon("JExplorer.gif","speichern")  );
        label1.setFont( new Font("Arial", Font.BOLD,28) );
        this.getContentPane().add(label1, 
                new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(0,0,0,0), 0, 0));

        JLabel label2 = new JLabel("JExplorer");
        label2.setFont( new Font("Arial", Font.BOLD,22) );
        this.getContentPane().add(label2, 
                new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(30,10,0,0), 0, 0));

        JLabel label3 = new JLabel( C_Version );
        label3.setFont( new Font("Arial", Font.BOLD,18) );
        this.getContentPane().add(label3, 
                new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(20,10,0,0), 0, 0));

        JLabel label4 = new JLabel( C_Copyright );
        label4.setFont( new Font("Arial", Font.BOLD,18) );
        this.getContentPane().add(label4, 
                new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(40,10,0,0), 0, 0));

        JLabel label5 = new JLabel("HS Harz, FB AI");
        label5.setFont( new Font("Arial", Font.BOLD,18) );
        this.getContentPane().add(label5, 
                new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(10,10,0,0), 0, 0));

        label6 = new JLabel("http://mwilhelm.hs-harz.de");
        label6.setFont( new Font("Arial", Font.BOLD,18) );
        this.getContentPane().add(label6, 
                new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(50,10,0,0), 0, 0));

        label7 = new JLabel("mwilhelm@hs-harz.de");
        label7.setFont( new Font("Arial", Font.BOLD,18) );
        this.getContentPane().add(label7, 
                new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(10,10,0,10), 0, 0));
       
        // versuch eine kleine horizontale Linie zu erzeugen
        // Ein JPanel "pnLinie" wird ins Hauptpanel eingetragen
        // dieses Panel hat aber kein Layout
        // desdhalb kann ein zweites Panel mit setBound gesetzt werden
        JPanel pnLinie = new JPanel();
        pnLinie.setBackground( Color.GRAY);
        pnLinie.setBackground( Color.RED);
        pnLinie.setLayout( null );

        JPanel pnLinie2 = new JPanel();
        pnLinie.add( pnLinie2 );
        // ohne setBounds wird es auf die gesamte Breite gezogen
        // pnLinie2.setBounds(0,0, 500,50);
        pnLinie2.setBackground( Color.GRAY);

        this.getContentPane().add(pnLinie, 
                new GridBagConstraints(0, 7, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(10,10,0,10), 0, 0));

        JButton BnESC = new JButton("Ok");
        BnESC.setFont( new Font("Arial", Font.BOLD,18)  );
        JPanel pn = new JPanel();
        pn.setLayout( new FlowLayout() );
        pn.add( BnESC);
        
        this.getContentPane().add(BnESC,   
            new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, 
                new Insets(20,0,0,10), 40, 0));
              
          BnESC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
              BnESC_Click();
            }
          });
        
        label1.setForeground(Color.blue);
        label6.setForeground(Color.blue);
        label7.setForeground(Color.blue);
        label6.addMouseListener(new java.awt.event.MouseAdapter() {

          public void mouseClicked(MouseEvent e) {
            www_Clicked();
          }
        });
        label7.addMouseListener(new java.awt.event.MouseAdapter() {

          public void mouseClicked(MouseEvent e) {
            email_Clicked();
          }
        });
        this.setBackground( Color.orange);
        this.setForeground(Color.orange);
          
    }

      // ButtonImage
  private ImageIcon loadIcon(String name, String description) {
   	// String path = "images" + name;
   	String path = name;  // Hier eventuell den path eintragen
    return new ImageIcon(path, description);
  }

    private void www_Clicked() {
       System.out.println("www") ;
       String s= "cmd /c start  "+label6.getText();
      try {
        
         Runtime.getRuntime().exec(s);
      }
      catch (IOException e) {
          System.out.println(e);
      }
    }

    // funktioniert noch nicht
    private void  email_Clicked() {
       System.out.println("email") ;
       String s= "cmd /c start "+label7.getText();
       s= "outlook.exe "+label7.getText();
      try {
        
         Runtime.getRuntime().exec(s);
      }
      catch (IOException e) {
          System.out.println(e);
      }
    }

    private void BnESC_Click() {
        setVisible(false);
        dispose();
    }
    
    
}
