package jexplorer;

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 21.04.2011
*/

// Hauptfenster des Programms

//Beschreibung:  Fast Vollstndiges Beispiel "Explorer in Java""
//                 Tabelle
//                 Ausfhren
//                 Popupmen

// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNodeRec liefert Zusatzinformationen, mit toString
// Analysiert eine Festplattenstruktur


import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

// Tree
import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.tree.*;


import java.io.*;

// ActionListener
public class JExplorer extends JFrame implements   IExplorer {
   
  private CTable _tabelle;  
  private CJToolBar _toolbar;
  
  private CTree _tree;
  private DefaultMutableTreeNode _rootNode;
  
  private TreePath _RootPath;  

  private DefaultMutableTreeNode _focusNode=null;
    
  private CStatusBar _statusBar;

  private CTimer  _clock;

  // da gemeinsames Event, notwendig als globale Variable
  private  JMenuItem MnLook_Feel_Windows;
  private  JMenuItem MnLook_Feel_Motif;
  private  JMenuItem MnLook_Feel_Metal;
  private  JMenuItem MnLook_Feel_Macintosh;

  private JCheckBoxMenuItem MnStatusbar;

  
    /** Creates a new instance of fcb_tree */
    public JExplorer() {
        setGUI();
        setMenues();
        CBasis.centerScreen(this,null);
        super.setVisible(true);  // sonst ist die Verschiebung sichtbar
    }
    
    
    
  private void setGUI() {
    _toolbar = new CJToolBar( this );

    setSize(900, 500);
    setTitle("JExplorer");
    this.getContentPane().setLayout( new BorderLayout() );

    _statusBar = new CStatusBar();
     this.getContentPane().add(_statusBar, BorderLayout.SOUTH);

     // Parameter  this=Interface     this=Frame
    _tabelle = new CTable( _statusBar, this, this  );      
    
  //  this.getContentPane().add( tabelle, BorderLayout.CENTER);
    
    

    this.getContentPane().add(_toolbar, BorderLayout.NORTH);
    
    _clock = new CTimer( _statusBar.getFirstLabel() );
    _clock.startLoading();
    
    setVisible(true);
   
    // dient dazu, das erste Laufwerk zu bestimmen
    File[] driveList = File.listRoots();
    _tree = new CTree( this, driveList[0].getPath() );
    
    // Splitter  links=Baum   rechts=tabelle
    JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,false,     
    new JScrollPane(_tree), _tabelle );
    
    split.setDividerLocation(350);

    this.getContentPane().add(split, BorderLayout.CENTER);

   
  }  // setGUI

  
       // setzt die Mens, alles vollstndig
  private void setMenues() {
    JMenuBar menuBar1 = new JMenuBar();

      // DATEI
    JMenu MainFile = new JMenu("Datei");

    JMenuItem MnClose = new JMenuItem("Schlieen");
    MainFile.add(MnClose);
    menuBar1.add(MainFile);

    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_Click();
      }
    });
    
    
    // ---------------------------------------
    JMenu MainTree= new JMenu("Baum");
    menuBar1.add(MainTree);
    
    JMenuItem MnTreeCompact= new JMenuItem("Nur Root");
    MnTreeCompact.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnTreeCompact_click();
      }
    });
    JMenuItem MnTreeExpand= new JMenuItem("Vollstndiger Baum");
    MnTreeExpand.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnTreeExpand_click();
      }
    });
    MainTree.add( MnTreeCompact);
    MainTree.add( MnTreeExpand);
    
    

    JMenu MainTable = new JMenu("Tabelle");
    menuBar1.add(MainTable);
    
    
    JMenuItem MnOpenFile = new JMenuItem("Datei ffnen");
    MnOpenFile.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F9,0));
    MainTable.add(MnOpenFile);
    MnOpenFile.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnOpenFile_click();
      }
    });


    JMenuItem MnEditFile= new JMenuItem("Datei in einem Editor");
    MnEditFile.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F12, 0));
    //MnEditFile.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F12, ActionEvent.CTRL_MASK));
    MainTable.add(MnEditFile);
    
    MnEditFile.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnEditFile_click();
      }
    });
    
    JMenuItem MnCreateDir = new JMenuItem("Verzeichnis anlegen");
    MainTable.add(MnCreateDir);
    MnCreateDir.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnCreateDir_click();
      }
    });
    
    JMenuItem MnRenameFile = new JMenuItem("Datei umbenennen");
    MainTable.add(MnRenameFile);
    MnRenameFile.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnRenameFile_click();
      }
    });
    
    MainTable.addSeparator();
    
    JMenuItem MnCountRowsFiles = new JMenuItem("Zeilensumme aller Dateien");
    MainTable.add(MnCountRowsFiles);
    MnCountRowsFiles.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnCountRowsFiles_click();
      }
    });
    
    MainTable.addSeparator();

    
    
    JMenuItem MnCopyFiles = new JMenuItem("Kopieren");
    MnCopyFiles.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_C,ActionEvent.CTRL_MASK));
    MainTable.add(MnCopyFiles);
    MnCopyFiles.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnCopyFiles_click();
      }
    });

    
    JMenuItem MnPasteFiles = new JMenuItem("Einfgen");
    MnCopyFiles.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_V,ActionEvent.CTRL_MASK));
    MainTable.add(MnPasteFiles);
    MnPasteFiles.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnPasteFiles_click();
      }
    });

    JMenuItem MnDeleteFiles = new JMenuItem("Lschen");
    MnDeleteFiles.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_X,ActionEvent.CTRL_MASK));
    MainTable.add(MnDeleteFiles);
    MnDeleteFiles.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnDeleteFiles_click();
      }
    });
    
    MainTable.addSeparator();
    
    
    
    JMenuItem MnSelectAll = new JMenuItem("alles Markieren");
    JMenuItem MnChangeSelect = new JMenuItem("Markierung umkehren");
    
   
    // --------------------------
    MnSelectAll.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnSelectAll_click();
      }
    });
    MnSelectAll.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.CTRL_MASK));
    MainTable.add(MnSelectAll);


    MnChangeSelect.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnChangeSelect_click();
      }
    });
    MainTable.add(MnChangeSelect);

    
    
    
    MainTable.addSeparator();
     // -----------
    JMenuItem MnReload = new JMenuItem("Aktualisieren");
    MnReload.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
    MainTable.add(MnReload);
    MnReload.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnReload_click();
      }
    });
    
    
     // -----------
     // -----------
     // -----------
     // -----------
    JMenu MainView = new JMenu("Ansicht");
   
    MnStatusbar = new JCheckBoxMenuItem("Statuszeile");
    MnStatusbar.setSelected(true);
    MainView.add(MnStatusbar);
    
    MnStatusbar.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnStatusbar_Click();
      }
    });
    // ---------------------------------
    
    JMenu MainLook_Feel = new JMenu("Look & Feel");

    MnLook_Feel_Windows = new JMenuItem("Windows");

    MainLook_Feel.add(MnLook_Feel_Windows);

    MnLook_Feel_Motif = new JMenuItem("Motif");
    MainLook_Feel.add(MnLook_Feel_Motif);

    MnLook_Feel_Metal = new JMenuItem("Metal");
    MainLook_Feel.add(MnLook_Feel_Metal);

    MnLook_Feel_Macintosh = new JMenuItem("Macintosh");
    MainLook_Feel.add(MnLook_Feel_Macintosh);

    
    
    menuBar1.add(MainLook_Feel);

    MnLook_Feel_Windows.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnLook_and_Feel(e);
      }
    });
    MnLook_Feel_Motif.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnLook_and_Feel(e);
      }
    });
    
    MnLook_Feel_Metal.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnLook_and_Feel(e);
      }
    });
    MnLook_Feel_Macintosh.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnLook_and_Feel(e);
      }
    });
    // --------------------------------
    
   
     // -----------
     // -----------
    JMenu MainOptions = new JMenu("Optionen");
    menuBar1.add(MainOptions);
   
    JMenuItem MnSystem = new JMenuItem("Java System");
    MainOptions.add(MnSystem);
    
    MnSystem.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnSystem_Click();
      }
    });
    
    MainOptions.addSeparator();
    
    JMenuItem MnOptions = new JMenuItem("Einstellungen");
    MainOptions.add(MnOptions);
    
    MnOptions.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnOptions_Click();
      }
    });
    
    
    
    // -------------------------------------
    JMenu MainHelp = new JMenu("Hilfe");
    JMenuItem MnProgInfo = new JMenuItem("Programm-Info");
    MainHelp.add(MnProgInfo);
    menuBar1.add(MainHelp);
    
    
    MnProgInfo.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnProgInfo_Click();
      }
    });
    
    // setzt alle Mens auf eine Schrift
   int m = menuBar1.getMenuCount();
    // System.out.println("Anzahl der Mens "+m);
    for (int i=0; i<m; i++) {
      JMenu main = menuBar1.getMenu(i);
      main.setFont( new Font("Arial", Font.BOLD,18)  );
      int n = main.getItemCount();
      // System.out.println("Anzahl der SubMens "+n);
      JMenuItem mn;
      for (int j=0; j<n; j++) {
        mn = main.getItem(j);
        // Abfrage auf Separator
        if ( mn instanceof JMenuItem )
        mn.setFont( new Font("Arial", Font.BOLD,18)  );
      }
    }    
    this.setJMenuBar(menuBar1);

  } // setMenu

  
  // -----------------------------------------------------
  // nun Aktionen
  
    private void  MnCut_click() {
        _tabelle.setCut();
        //_statusBar.setText2("Cut");
    }
    
    private void  MnCopy_click() {
        _tabelle.setCopy();        
        // _statusBar.setText1("Copy");
    }
        
    private void  MnPaste_click() {
        _tabelle.setInsert();        
        _statusBar.setText2("Insert");
    }

    private void  MnSelectAll_click(){
        _tabelle.selectALL();
    }
    private void  MnChangeSelect_click() {
        _tabelle.changeSelect();
    }

    private void MnEditFile_click() {
        String sFile = _tabelle.getSelectedFile();
        if ( sFile!= null) {
            File f = new File(sFile);
            if (f.exists()) {
                if ( f.length()>6500000) {
                    CBasis.Message("Datei laden","Java kann maximal 7MB Dateien laden");
                    return;
                }
                JFEditor edit = new JFEditor(sFile);
            }
        }
    }

    private void MnOpenFile_click() {
        _tabelle.lk_openFile();
    }
    
    private void MnCopyFiles_click() {
        _tabelle.lk_copyFile();
    }
        
    private void MnPasteFiles_click() {
        _tabelle.lk_pasteFile();
    }
    
    private void MnDeleteFiles_click() {        
        _tabelle.lk_deleteFile();
    }
        
    private void MnCreateDir_click() {
        _tabelle.lk_mkdir();
    }
        
    private void MnRenameFile_click() {
        _tabelle.lk_renameFile();
    }

    
    private void MnCountRowsFiles_click() {
        _tabelle.CountRowsFiles();
    }
    
    private void MnReload_click() {
        _tabelle.reload();
    }
    
    public void reloadNode(String sPath) {
        _tree.reloadNode();
    }
    
    private void MnTreeCompact_click() {
        _tree.collapse();
    }
    
    private void MnTreeExpand_click() {
        _tree.expand();        
    }
    
    private void MnStatusbar_Click() {        
        _statusBar.setVisible(  MnStatusbar.isSelected()  );
    }    
    
    // setzt das Aussehen
      public void MnLook_and_Feel(ActionEvent e) {
         try {
           if (e.getSource() ==  MnLook_Feel_Windows ) {
               UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
               SwingUtilities.updateComponentTreeUI(this.getContentPane() );
               return;
           }
           if (e.getSource() ==  MnLook_Feel_Metal ) {
               UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
              SwingUtilities.updateComponentTreeUI(this.getContentPane() );
               return;
           }
           if (e.getSource() ==  MnLook_Feel_Motif ) {
               UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
               SwingUtilities.updateComponentTreeUI(this.getContentPane() );
               return;
           }
           if (e.getSource() ==  MnLook_Feel_Macintosh ) {
               UIManager.setLookAndFeel("javax.swing.plaf.mac.MacLookAndFeel");
               SwingUtilities.updateComponentTreeUI(this.getContentPane() );
               return;
           }
         } catch (Exception exc) {
         }

    }  // look & Feel
      
      
      
      private void MnClose_Click() {
          dispose();
      }
   
   private void MnSystem_Click() {
     //System.out.println("Programm-Info");
     JDSystem frame = new JDSystem(this);
     // frame.setVisible(true);
       
   }
      
   private void MnOptions_Click() {
     //System.out.println("Programm-Info");
     JDOptions frame = new JDOptions(this);
     // frame.setVisible(true);
       
   }

      
   private  void MnProgInfo_Click() {
    //System.out.println("Programm-Info");
    JDProgInfo frame = new JDProgInfo(this);
    frame.setVisible(true);
  }

	// setzt das TreeFeld auf ein Laufwerk Aufruf in TreeFeld
    public void setRoot(String sRootName) { 			  
       _tree.setRoot( sRootName );
    }//setRoot
    
    // Aktualisierung in der Tabelle
    public void setTableDir( String sPath ) {
        _tabelle.setDir(  sPath);
    }
    
    
    public void setTitle(String Caption) {
        super.setTitle( Caption  );
    }
  
    
    
	// Setzt den Focus dahin, wo die man anklickt, wird bei jeden anklicken aufgerufen  
    public void setFocusNode(DefaultMutableTreeNode fN) {    
    	_focusNode = fN;		
    }//setFocusNode

	// holt sich den Focus fr die Tabelle, wenn man in der Tab.struktur in Ordner wechselt
    public DefaultMutableTreeNode getFocusNode() {     
    	return _focusNode;
    }//DefaultMutableTreeNode



        
  




    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
            JExplorer frame = new JExplorer();

//    	try 
//    	{	
//    		// Angepasster Windowslook des Java Explorers
//            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
//            JExplorer frame = new JExplorer();
//    	}
//    	catch (Exception e) 
//    	{
//      		System.out.println("unbekanntes Look & Feel");
//    	}
        
    }
    
}



