package jexplorer;

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Zeigt ein Fenster an, das den verlauf des Kopierens
// Natrlich mit einem Thread
// UND es regelt die Single-Thread-Rule, AWT-Problem

// wird von der Klasse CTable aufgerufen 

import javax.swing.*;

import java.awt.*;

import java.util.Vector;

import java.io.*;


public class JFCopyDialog extends JFrame implements Runnable {
    
    String sSrcDirectory; 
    String sDestDirectory;
    Vector kopyListe;
    
    JLabel label1a= new JLabel("von");    
    JLabel label2a= new JLabel("bis");
            
    JLabel label1b= new JLabel("C:\\");    
    JLabel label2b= new JLabel("D:\\");

    JLabel label3a= new JLabel("Datei:");    
    public JLabel label3b= new JLabel("test.dat");
    
    long _summe1=0;  // Gesamtsumme
    long _summe2=0;  // laufende Summe
    
    public JProgressBar progress = new JProgressBar();
    
    JButton BnESC = new JButton("Abbrechen");

    // parent wird gebraucht, siehe Interface 
    // zeigt am ende des Kopierens, dass die tabelle neu lesen muss
    ITableSetDir _parent;
    
    public int progress_value=0;
    
    // Thread Methode
    public void run() {
        if (progress_value>0) {
            progress.setValue(progress_value);
            progress.updateUI();
        }       
    }
   
    /** Creates a new instance of CopyDialog */
    public JFCopyDialog( ITableSetDir parent,  String sSrcDirectory, String sDestDirectory, Vector kopyListe ) {
        setSize(500,370);
        setTitle("Kopieren von Dateien");
        _parent = parent;
        this.sSrcDirectory = sSrcDirectory;   // Quellverzeichnis
        this.sDestDirectory = sDestDirectory; // Ziel
        this.kopyListe = kopyListe;  // Liste der Dateien, noch ohne Verzeichnisse
        setGUI();
        CBasis.centerScreen(this,null);
    }
    
    
    void setGUI() {
        setLayout( new GridBagLayout() );
        
       label1b.setText( sSrcDirectory );
       label2b.setText( sDestDirectory );
       
       label1b.updateUI();
       label2b.updateUI();
       

       label1a.setFont( new Font("Arial", Font.BOLD,18)  );
       label1b.setFont( new Font("Arial", Font.BOLD,18)  );
       label2a.setFont( new Font("Arial", Font.BOLD,18)  );
       label2b.setFont( new Font("Arial", Font.BOLD,18)  );
       label3a.setFont( new Font("Arial", Font.BOLD,18)  );
       label3b.setFont( new Font("Arial", Font.BOLD,18)  );


       this.getContentPane().add(label1a, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(30,20,0,0), 0, 0));

       this.getContentPane().add(label1b,   new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(30,40,0,20), 00, 0));


      
      this.getContentPane().add(label2a, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(label2b,   new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(30,40,0,20), 00, 0));

        
      
        this.getContentPane().add(label3a, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(30,20,0,0), 0, 0));


        this.getContentPane().add(label3b,   new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(30,40,0,20), 00, 0));

        
        this.getContentPane().add(progress,   new GridBagConstraints(0, 3, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(40,10,0,10), 00, 30));
        
        BnESC.setFont( new Font("Arial", Font.BOLD,18)  );
        JPanel pn = new JPanel();
        pn.setLayout( new FlowLayout() );
        pn.add( BnESC);
        
        this.getContentPane().add(pn,   new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(25,0,0,0), 0, 0));
      
    }
    
    
    // wird von CTable aufgerufen, startet das Kopieren
    // dient dazu dass das Fenster angezeigt wird
    void copyFiles() {
        _summe2=0;
        _summe1 = 0;
        // bestimmen der Gesamtsumme, ProgressBar
        for (int i=0; i<kopyListe.size(); i++) {
              CFile myfile = (CFile) kopyListe.elementAt(i);
              _summe1 += myfile.length;
        }
        
        CGuiThread thread = new CGuiThread();
        thread.start();
    }

    
        class CGuiThread  extends Thread {
            public void run() {
              for (int i=0; i<kopyListe.size(); i++) {
                  CFile myfile = (CFile) kopyListe.elementAt(i);
                   String src = sSrcDirectory+myfile.Name;
                   String dest = sDestDirectory+myfile.Name;
                  FileInputStream fsrc;  // File Handler
                  FileOutputStream fdest;  // File Handler
                    byte data[]= new byte[10000];  
                    try {
                      fsrc = new FileInputStream(src);
                      fdest = new FileOutputStream(dest);
                      int n = fsrc.read(data);  // lesen eines Blockes
                      while (n>0) {
                        fdest.write(data,0, n);  // schreiben eines Blockes                  
                        _summe2 += n;
                        // Prozentrechnung
                        double d =  100.0*( (_summe2*1.0)/_summe1);
                        int k = (int)  (d);
                        if (k>0) {
                           progress.setValue(k);
                           label3b.setText( myfile.Name  );                                    
                        }

                        n = fsrc.read(data);  // lesen eines Blockes
                            // Pause
                        /* try {
                            Thread.sleep(50);
                          }
                          catch (InterruptedException e) {
                          }                
*/
                      }
                     fsrc.close();             
                     fdest.close();              
                   }
                    catch (IOException io)
                    { 
                        System.out.println("IOException"); 
                    }
                  
                  
              }  // for
              _parent.setDir(sDestDirectory);
              dispose();        
            }  // run
        
        }
}

