package jexplorer;

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Einfacher Editor
// laden und speichern erfolgt ber einen Thread
// man kann beim laden schon schreiben
// Schrift ist Online nderbar
// Tabgre einstellbar

// Optionen:  Open

import java.awt.*;
import java.io.File;
import javax.swing.*;
import javax.swing.event.*;

import java.awt.event.*;


// frs lesen aus Datei
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;
import java.io.FileReader;
import java.io.FileWriter;


// Plain Dokument
import javax.swing.text.PlainDocument;
import javax.swing.text.BadLocationException;
import javax.swing.text.AttributeSet;

import javax.swing.text.Document;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

// Open Save Dialog
// Opendialog
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.*;
import java.util.Hashtable;
import java.util.Enumeration;

// Filter
/*import javax.swing.filechooser.*;
import java.io.File;
import java.util.Hashtable;
import java.util.Enumeration;
*/

public class JFEditor extends JFrame implements IModify{

  private JMenuBar menuBar1;
  private JMenu MainFile;
  private JMenuItem MnSave;
  private JMenuItem MnSaveAs;
  private JMenuItem MnClose;
  
  private JMenu MainEdit;
  private JMenuItem MnCut;
  private JMenuItem MnCopy;
  private JMenuItem MnPaste;
  private JMenuItem MnSelectAll;
    
    private JTextArea _editor = new JTextArea();
    private String _sFileName;
    
    private boolean _bModify=false;

  private JSpinner spTabSize;
  private JSpinner spFontSize;
  
  // Statuszeile ist hier eine Komponente, so dass man
  // beliebige GUI-Elemente eintragen kann
  protected CStatusBar_JComponent _statusBar;
 // JProgressBar _progress;
    
    /** Creates a new instance of JFEditor */
    public JFEditor(String sFileName) {
        _sFileName = sFileName;
        setGUI();
        setMenues();
        setToolBars();
        readFile(_sFileName);
        setVisible(true);
        changeTabSize();
        
        setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );
        // setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        // Hiermit wird verh7indert, dass Java das Hauptfenster sofort schliet
        // Nur unter Aufsicht
        this.addWindowListener(new java.awt.event.WindowAdapter() {

          public void windowClosing(WindowEvent e) {
            // this_windowClosing(e);
            Closing();
          }
        });
    }

    void Closing(){
        if (_bModify) {
                int retcode = CBasis.YesNoEsc("Editor beenden?", 
                        "Wollen Sie die nderung in\n"+getCaption()+ "\nspeichern?");
                switch (retcode) {
                  case CBasis.YES : if ( _sFileName==null )
                                          MnSaveAs_Click();
                                        else
                                          MnSave_Click();
                                    break;
                  case CBasis.NO:   break;
                  case CBasis.ESC : return;                            
                }  // switch              
            
        }
        dispose();
    }  // Closing


    void MnClose_actionPerformed(ActionEvent e) {
          Closing();
    }  // Mainfenster Closing
  
    
    
    private void setGUI() {
        setSize(800, 500);
        setLocation(100,100);
        setTitle( getCaption() );
        this.getContentPane().setLayout( new BorderLayout() );
        this.getContentPane().add( new JScrollPane(_editor), BorderLayout.CENTER);
        _editor.setFont( new Font("Arial", Font.BOLD,18)  );        
        _editor.setFont(new Font("monospaced", Font.PLAIN, 16));

        EditTextDocument doc = new EditTextDocument(this);
 	_editor.setDocument( doc );

        _statusBar = new CStatusBar_JComponent();
        
        this.getContentPane().add(_statusBar, BorderLayout.SOUTH);

    }
    
    

    // umgeht das Problem, dass eine neue Datei keinen Namen hat
  private String getCaption() {
      if (_sFileName == null)
        return "noname";
      else
        return _sFileName;      
  }  
    
     
     
     
     
       // ButtonImage
  private ImageIcon loadIcon(String name, String description) {
   	// String path = "images" + name;
   	String path = name;  // Hier eventuell den path eintragen
    return new ImageIcon(path, description);
  }
    
private void setToolBars() {
    JToolBar toolBar = new JToolBar();

    JButton BnSave = new JButton("Speichern");
    BnSave.setFont( new Font("Arial", Font.BOLD,18)  );
    BnSave.setIcon( loadIcon("cut.gif","auschneiden") );

    
    JButton BnCut = new JButton("Ausschneiden");
    BnCut.setFont( new Font("Arial", Font.BOLD,18)  );
    BnCut.setIcon( loadIcon("cut.gif","auschneiden") );

    JButton BnCopy = new JButton("Kopy");
    BnCopy.setIcon( loadIcon("copy.gif","neu") );
    BnCopy.setFont( new Font("Arial", Font.BOLD,18)  );

    JButton BnPaste = new JButton("Einfgen");
    BnPaste.setIcon( loadIcon("paste.gif","neu") );
    BnPaste.setFont( new Font("Arial", Font.BOLD,18)  );

    toolBar.add(BnSave);
    BnSave.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        MnSave_Click();  // !!!!!!
      }
    });

    toolBar.addSeparator();
  
    toolBar.add(BnCut);
    BnCut.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        MnCut_click();  // !!!!!!
      }
    });

    toolBar.addSeparator();

    toolBar.add(BnCopy);
    BnCopy.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        MnCopy_click();  // !!!!!!
      }
    });
    
    toolBar.addSeparator();

    toolBar.add(BnPaste);
    BnPaste.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        MnPaste_click();  // !!!!!!
      }
    });
    

    
    spTabSize = new JSpinner( new SpinnerNumberModel(3,3, 20, 1)   );
    spFontSize = new JSpinner( new SpinnerNumberModel(16,2, 100, 1)   );
    spTabSize.setToolTipText("Setzt die Tabgre als Leerzeichen");
    spFontSize.setToolTipText("Setzt die Schriftgre");
    
    spTabSize.setFont( new Font("Arial", Font.BOLD,18)  );        
    spFontSize.setFont( new Font("Arial", Font.BOLD,18)  );
    // TTabSize.setBounds(0,0,30,2);  // top left width height
    //TTabSize.setBounds( new Dimension(100,2)));
    
    toolBar.addSeparator();
    toolBar.addSeparator();

    toolBar.add(spTabSize);
    toolBar.addSeparator();
    toolBar.add(spFontSize);

    spTabSize.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                changeTabSize();
            }
        });
    spFontSize.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                changeFontSize();
            }
        });
    
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
  } // setToolBars
    
    

       // setzt die Mens, alles vollstndig
  private void setMenues() {
    menuBar1 = new JMenuBar();

      // DATEI
    MainFile = new JMenu("Datei");

    MnSave = new JMenuItem("Speichern");
    MnSaveAs = new JMenuItem("Speichern Als");

    MnSave.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnSave_Click();
      }
    });
    MnSaveAs.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnSaveAs_Click();
      }
    });
    MainFile.add(MnSave);
    MainFile.add(MnSaveAs);
    MainFile.addSeparator();
    
    
    MnClose = new JMenuItem("Schlieen");
    MainFile.add(MnClose);
    menuBar1.add(MainFile);

    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_Click();
      }
    });
    
    // ----------------------------------
    // EDIT
    MainEdit = new JMenu("Bearbeiten");
    MnCut = new JMenuItem("Ausschneiden");
    MnCopy = new JMenuItem("Kopieren");
    MnPaste = new JMenuItem("Einfgen");

    MnSelectAll = new JMenuItem("alles Markieren");
    

    
    MnCut.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnCut_click();
      }
    });
    MnCut.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
    MainEdit.add(MnCut);

    MnCopy.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnCopy_click();
      }
    });
    MnCopy.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
    MainEdit.add(MnCopy);
    // MainFile.addSeparator();

    // --------------------------
    MnPaste.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnPaste_click();
      }
    });
    MnPaste.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK));
    MainEdit.add(MnPaste);
    
    MainEdit.addSeparator();

    // --------------------------
    MnSelectAll.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnSelectAll_click();
      }
    });
    MnSelectAll.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.CTRL_MASK));
    MainEdit.add(MnSelectAll);
    
    menuBar1.add(MainEdit);

    
   int m = menuBar1.getMenuCount();
    System.out.println("Anzahl der Mens "+m);
    for (int i=0; i<m; i++) {
      JMenu main = menuBar1.getMenu(i);
      main.setFont( new Font("Arial", Font.BOLD,18)  );
      int n = main.getItemCount();
      System.out.println("Anzahl der SubMens "+n);
      JMenuItem mn;
      for (int j=0; j<n; j++) {
        mn = main.getItem(j);
        // Abfrage auf Separator
        if ( mn instanceof JMenuItem )
        mn.setFont( new Font("Arial", Font.BOLD,18)  );
      }
    }    
    this.setJMenuBar(menuBar1);

  } // setMenu
    
    private void  MnCut_click() {
         _editor.cut();
    }
    
    private void  MnCopy_click() {
        _editor.copy();
    }
        
    private void  MnPaste_click() {
        _editor.paste();
    }

    private void  MnSelectAll_click(){
        _editor.selectAll();
    }
    
      private void MnClose_Click() {
          dispose();
      }


      // liest die datei als Thread ein
      // Single-Thread-Rule eingehalten
  private void readFile(String sFilename) {
    if ( sFilename == null ) {
      System.out.println("Dateiname leer");
      _editor.setText("");
      return;
    }
    File f = new File(sFilename);
    if (f.exists()) {
        Thread loader = new FileLoader(this, f,_editor.getDocument(), _statusBar);
        loader.start();
    }
    _bModify=false;  // wird durch den EditListener automatisch gesetzt, also
                    // jetzt zurcksetzen

  }  // readFile
      
      
  // Konventionell, ohne Thread
  // wenn aktiviert, das wird das Fenster erst am Schluss angezeigt
  // Keine Reaktion beim Lesen
  private void rreadFile(String sFilename) {
    if ( sFilename == null ) {
      System.out.println("Dateiname leer");
      _editor.setText("");
      return;
    }
    char[] buff = new char[4096];
    int nch;
    String s="";
    
    try {
        Reader in = new FileReader(sFilename);
        while ((nch = in.read(buff, 0, buff.length)) != -1) {
            s=s+new String(buff, 0, nch);
        }
        in.close();
        _editor.setText(s);
        _bModify=false;  // wird durch den EditListene automatisch gesetzt
    }
    catch (IOException e) {
		System.err.println(e.toString());
    }      
  }  // readFile

  
  // Speichert die Datei mit Hilfe eines Thread
  // Hlt die Single-Thread-Rule ein
  public void saveFile(String sFileName) {
      if (sFileName == null) {
      }
      else {
        String s=_editor.getText();
        Thread saver = new FileSaver( sFileName, s);
        saver.start();          
      }
    System.out.println("save Editor");
    _bModify=false;      
  }

  
  private void MnSave_Click() {
      saveFile(_sFileName);
  }
  
  
  private void MnSaveAs_Click() {
   JFileChooser jFileChooser1 = new JFileChooser();
   String sFileName;

   File file = new File("D:\\HS-Harz\\Vorlesungen\\java\\netbeans\\");
   if ( file.isDirectory() )
    jFileChooser1.setCurrentDirectory( file );
   else
    jFileChooser1.setCurrentDirectory( new File("C:\\") );
   
	// starten und Ok-Schalter gedrckt ?
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
      _sFileName = jFileChooser1.getSelectedFile().getPath();
      setTitle( getCaption() );
      MnSave_Click();
    }
  }  // SaveAs
  
  
  // wird vom Plain-Dokument gesetzt
  public void setModify(boolean bModify) {
      _bModify=bModify;
      setTitle("modify gesetzt");
  }

  
  
  private void  changeTabSize() {
    Integer I = (Integer) spTabSize.getValue();
    int tabsize = I.intValue();
    _editor.setTabSize(tabsize);
  }
      
  private void changeFontSize() {
    Integer I = (Integer) spFontSize.getValue();
    int fontsize = I.intValue();
    _editor.setFont(new Font("monospaced", Font.PLAIN, fontsize));

  }    
      
  
}// JFEditor


// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------

// Private Klassen

interface IModify {
    public void setModify(boolean bModify);
}


// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------



// Diese Klasse wird in das Dokument des Editors gehngt
// Damit kann man nderungen erkennen
// Praktisch kann man auch Texte nicht zulassen
class EditTextDocument extends PlainDocument {
    IModify _parent;
    public EditTextDocument(IModify parent) {
      _parent = parent;
      System.out.println("           EditIntTextDocument");
    }

    public void insertString(int offs, String str, AttributeSet a) throws BadLocationException {
      _parent.setModify(true);
      System.out.println("           gIntTextDocument: insertString");
      // if (str.equals("x"))  return;
      // if (str.equals("wilhelm"))  return;
      super.insertString(offs, str, a);
    }

  public void remove(int offs, int len)  throws BadLocationException {
      _parent.setModify(true);
      super.remove(offs, len);
  }
  
  
  
  
}


// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------

    // einfache Komponente, JComponent ist abstract
    // ein JPanel wre aber auch mglich
    class CStatusBar_JComponent extends JComponent {

        public CStatusBar_JComponent() {
	    super();
	    setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
  	}

        public void paint(Graphics g) {
	   super.paint(g);
	}

    }




/**
 * Thread zum Laden einer Datei
 */
class FileLoader extends Thread {
    Document _doc;
    File _f;
    CStatusBar_JComponent _statusBar;
    IModify _parent;

    // bergabe einer Statuszeile, in der kann alles eingetragen werden
    FileLoader(IModify parent, File f, Document doc, CStatusBar_JComponent statusBar) {
        setPriority( Thread.MIN_PRIORITY); //  4);
        _parent = parent;
        _f = f;
        _doc = doc;
        _statusBar = statusBar;
    }

    // Thread Methode
    public void run() {
        try {
            // initialize the statusbar
            _statusBar.removeAll();
            JProgressBar progress = new JProgressBar();
            progress.setMinimum(0);
            progress.setMaximum((int) _f.length());
            _statusBar.add(progress);
            _statusBar.revalidate();

            // try to start reading
            Reader in = new FileReader(_f);
            char[] buff = new char[8192];
            int nch;
            while ((nch = in.read(buff, 0, buff.length)) != -1) {
                _doc.insertString(_doc.getLength(), new String(buff, 0, nch), null);
                progress.setValue(progress.getValue() + nch);
            }
            progress.setValue( 0 );
            // Nun Ende
            _statusBar.removeAll(); // Alle Elemente entfernen
            _statusBar.revalidate();
            _parent.setModify(false);
        }
        catch (IOException e) {
            System.err.println(e.toString());
        }
        catch (BadLocationException e) {
            System.err.println(e.getMessage());
        }
    }
}





/**
 * Thread zum Speichern einer Datei
 */
class FileSaver extends Thread {
    Document _doc;
    String _sFileName;
    String _sText;

    // bergabe einer Statuszeile, in der kann alles eingetragen werden
    FileSaver(String sFileName, String sText) {
        setPriority( Thread.MIN_PRIORITY); //  4);
        _sFileName = sFileName;
        _sText = sText;
    }

        // Thread Methode, hier kein ProgessBar
    public void run() {
        try {
            Writer out = new FileWriter(_sFileName);
            out.write(_sText);
            out.close();            
        }
        catch (IOException e) {
            System.err.println(e.toString());
        }
    }
}
